"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkdownHints = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const md_hints_1 = require(".././../../i18n/md-hints");
const classname_1 = require("../../../classname");
const b = (0, classname_1.cn)('markdown-hints');
const YFM_DOCS_HREF = 'https://ydocs.tech';
exports.MarkdownHints = react_1.default.memo(function MarkdownHints() {
    const hints = [
        { title: (0, md_hints_1.i18n)('header_title'), hint: (0, md_hints_1.i18n)('header_hint') },
        { title: (0, md_hints_1.i18n)('italic_title'), hint: (0, md_hints_1.i18n)('italic_hint') },
        { title: (0, md_hints_1.i18n)('bold_title'), hint: (0, md_hints_1.i18n)('bold_hint') },
        { title: (0, md_hints_1.i18n)('strikethrough_title'), hint: (0, md_hints_1.i18n)('strikethrough_hint') },
        { title: (0, md_hints_1.i18n)('blockquote_title'), hint: (0, md_hints_1.i18n)('blockquote_hint') },
        { title: (0, md_hints_1.i18n)('code_title'), hint: (0, md_hints_1.i18n)('code_hint') },
        { title: (0, md_hints_1.i18n)('link_title'), hint: (0, md_hints_1.i18n)('link_hint') },
        { title: (0, md_hints_1.i18n)('image_title'), hint: (0, md_hints_1.i18n)('image_hint') },
        { title: (0, md_hints_1.i18n)('list_title'), hint: (0, md_hints_1.i18n)('list_hint') },
        { title: (0, md_hints_1.i18n)('numbered-list_title'), hint: (0, md_hints_1.i18n)('numbered-list_hint') },
    ];
    return (react_1.default.createElement("div", { className: b() },
        react_1.default.createElement("div", { className: b('grid') }, hints.map((hint, index) => (react_1.default.createElement(react_1.default.Fragment, { key: `md-hint-${index}` },
            react_1.default.createElement("span", { className: b('title') }, hint.title),
            react_1.default.createElement("span", { className: b('hint') }, hint.hint))))),
        react_1.default.createElement(uikit_1.Link, { href: YFM_DOCS_HREF, target: "_blank", className: b('docs-link') }, (0, md_hints_1.i18n)('documentation'))));
});
exports.MarkdownHints.displayName = 'MarkdownHints';
