import React from 'react';
import { ClassNameProps } from '../../classname';
import type { EditorMode, SplitMode } from '../Editor';
export declare type EditorSettingsProps = SettingsContentProps & {
    renderPreviewButton?: boolean;
};
export declare const EditorSettings: React.NamedExoticComponent<EditorSettingsProps>;
declare type SettingsContentProps = ClassNameProps & {
    mode: EditorMode;
    onModeChange: (mode: EditorMode) => void;
    onShowPreviewChange: (showPreview: boolean) => void;
    showPreview: boolean;
    toolbarVisibility: boolean;
    onToolbarVisibilityChange: (val: boolean) => void;
    splitMode?: SplitMode;
    splitModeEnabled?: boolean;
    onSplitModeChange?: (splitModeEnabled: boolean) => void;
};
export {};
