import { ExtensionAuto } from '../core';
import { BehaviorPresetOptions } from '../extensions/behavior';
import { EditorModeKeymapOptions } from '../extensions/behavior/EditorModeKeymap';
import { FullPresetOptions } from '../presets/full';
import type { FileUploadHandler } from '../utils/upload';
import { EditorPreset } from './Editor';
export declare type ExtensionsOptions = BehaviorPresetOptions & FullPresetOptions;
export declare type BundlePresetOptions = ExtensionsOptions & EditorModeKeymapOptions & {
    preset: EditorPreset;
    mdBreaks?: boolean;
    fileUploadHandler?: FileUploadHandler;
    /**
     * If we need to set dimensions for uploaded images
     *
     * @default false
     */
    needToSetDimensionsForUploadedImages?: boolean;
};
export declare const BundlePreset: ExtensionAuto<BundlePresetOptions>;
