"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkForm = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const TextInput_1 = require("../../../../../forms/TextInput");
const UrlInputRow_1 = require("../../../../../forms/UrlInputRow");
const base_1 = tslib_1.__importDefault(require("../../../../../forms/base"));
const utils_1 = require("../../../../../forms/utils");
const forms_1 = require("../../../../../i18n/forms");
exports.LinkForm = react_1.default.memo(function LinkForm({ href, autoFocus, onChange, onCancel, }) {
    const [url, setUrl] = react_1.default.useState(href);
    const handleSubmit = () => {
        onChange === null || onChange === void 0 ? void 0 : onChange({ href: url });
    };
    const inputEnterKeyHandler = (0, utils_1.enterKeyHandler)(handleSubmit);
    return (react_1.default.createElement(base_1.default.Form, null,
        react_1.default.createElement(base_1.default.Layout, null,
            react_1.default.createElement(base_1.default.Row, { label: (0, forms_1.i18n)('common_link'), help: (0, forms_1.i18n)('link_url_help'), control: react_1.default.createElement(UrlInputRow_1.UrlInputRow, { href: url, input: react_1.default.createElement(TextInput_1.TextInputFixed, { size: "s", hasClear: true, view: "normal", value: url, onUpdate: setUrl, placeholder: "https://", autoFocus: autoFocus, onKeyPress: inputEnterKeyHandler }) }) })),
        react_1.default.createElement(base_1.default.Footer, { onCancel: onCancel, onSubmit: handleSubmit })));
});
