"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.actions = void 0;
const prosemirror_schema_list_1 = require("prosemirror-schema-list");
const commands_1 = require("./commands");
const const_1 = require("./const");
const utils_1 = require("./utils");
exports.actions = {
    toBulletList: ({ schema }) => {
        const toBulletList = (0, commands_1.toList)((0, utils_1.blType)(schema));
        return {
            isActive: (0, utils_1.isIntoListOfType)(const_1.ListNode.BulletList),
            isEnable: toBulletList,
            run: toBulletList,
        };
    },
    toOrderedList: ({ schema }) => {
        const toOrderedList = (0, commands_1.toList)((0, utils_1.olType)(schema));
        return {
            isActive: (0, utils_1.isIntoListOfType)(const_1.ListNode.OrderedList),
            isEnable: toOrderedList,
            run: toOrderedList,
        };
    },
    liftListItem: ({ schema }) => {
        return {
            isEnable: (0, prosemirror_schema_list_1.liftListItem)((0, utils_1.liType)(schema)),
            run: (0, prosemirror_schema_list_1.liftListItem)((0, utils_1.liType)(schema)),
        };
    },
    sinkListItem: ({ schema }) => {
        return {
            isEnable: (0, prosemirror_schema_list_1.sinkListItem)((0, utils_1.liType)(schema)),
            run: (0, prosemirror_schema_list_1.sinkListItem)((0, utils_1.liType)(schema)),
        };
    },
};
