"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StrikeSpecs = exports.strikeType = exports.strikeMarkName = void 0;
const schema_1 = require("../../../../utils/schema");
exports.strikeMarkName = 'strike';
exports.strikeType = (0, schema_1.markTypeFactory)(exports.strikeMarkName);
const StrikeSpecs = (builder) => {
    builder.addMark(exports.strikeMarkName, () => ({
        spec: {
            parseDOM: [{ tag: 'strike' }, { tag: 's' }],
            toDOM() {
                return ['strike'];
            },
        },
        fromMd: {
            tokenSpec: {
                name: exports.strikeMarkName,
                type: 'mark',
            },
            tokenName: 's',
        },
        toMd: { open: '~~', close: '~~', mixable: true, expelEnclosingWhitespace: true },
    }));
};
exports.StrikeSpecs = StrikeSpecs;
