"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tableCellContextPlugin = void 0;
const prosemirror_state_1 = require("prosemirror-state");
const core_1 = require("../../../../../core");
const yfm_1 = require("../../../../yfm");
const TableSpecs_1 = require("../../TableSpecs");
const innerActions_1 = require("../../actions/innerActions");
const tableActions_1 = require("../../actions/tableActions");
const view_1 = require("./view");
const tableCellContextPlugin = () => new prosemirror_state_1.Plugin({
    view(view) {
        const { schema } = view.state;
        const actions = (0, core_1.bindActions)(Object.assign(Object.assign({}, innerActions_1.innerActions), { deleteTable: tableActions_1.deleteTableAction, convert: {
                isEnable: yfm_1.convertToYfmTable,
                run: yfm_1.convertToYfmTable,
            } }))(view);
        return new view_1.TableCellContextView(view, [
            [
                { action: actions.setCellLeftAlign, text: 'left' },
                { action: actions.setCellCenterAlign, text: 'center' },
                { action: actions.setCellRightAlign, text: 'right' },
            ],
            [
                { action: actions.addRow, text: 'add row' },
                { action: actions.deleteRow, text: 'del row' },
                { action: actions.addColumn, text: 'add column' },
                { action: actions.deleteColumn, text: 'del column' },
            ],
            { action: actions.convert, text: 'convert to yfm table' },
            { action: actions.deleteTable, text: 'del table' },
        ], [schema.nodes[TableSpecs_1.TableNode.HeaderCell], schema.nodes[TableSpecs_1.TableNode.DataCell]]);
    },
});
exports.tableCellContextPlugin = tableCellContextPlugin;
