"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckboxSpecs = exports.checkboxInputType = exports.checkboxLabelType = exports.checkboxType = exports.CheckboxNode = void 0;
const tslib_1 = require("tslib");
const checkbox_1 = tslib_1.__importDefault(require("@diplodoc/transform/lib/plugins/checkbox"));
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
const parser_1 = require("./parser");
const schema_2 = require("./schema");
const serializer_1 = require("./serializer");
var const_2 = require("./const");
Object.defineProperty(exports, "CheckboxNode", { enumerable: true, get: function () { return const_2.CheckboxNode; } });
exports.checkboxType = (0, schema_1.nodeTypeFactory)(const_1.CheckboxNode.Checkbox);
exports.checkboxLabelType = (0, schema_1.nodeTypeFactory)(const_1.CheckboxNode.Label);
exports.checkboxInputType = (0, schema_1.nodeTypeFactory)(const_1.CheckboxNode.Input);
const CheckboxSpecs = (builder, opts) => {
    const schemaSpecs = (0, schema_2.getSchemaSpecs)(opts, builder.context.get('placeholder'));
    builder
        .configureMd((md) => (0, checkbox_1.default)(md, { idPrefix: const_1.idPrefix, divClass: (0, const_1.b)() }))
        .addNode(const_1.CheckboxNode.Checkbox, () => ({
        spec: schemaSpecs[const_1.CheckboxNode.Checkbox],
        toMd: serializer_1.serializerTokens[const_1.CheckboxNode.Checkbox],
        fromMd: {
            tokenSpec: parser_1.parserTokens[const_1.CheckboxNode.Checkbox],
        },
        view: opts.checkboxView,
    }))
        .addNode(const_1.CheckboxNode.Input, () => ({
        spec: schemaSpecs[const_1.CheckboxNode.Input],
        toMd: serializer_1.serializerTokens[const_1.CheckboxNode.Input],
        fromMd: {
            tokenSpec: parser_1.parserTokens[const_1.CheckboxNode.Input],
        },
        view: opts.inputView,
    }))
        .addNode(const_1.CheckboxNode.Label, () => ({
        spec: schemaSpecs[const_1.CheckboxNode.Label],
        toMd: serializer_1.serializerTokens[const_1.CheckboxNode.Label],
        fromMd: {
            tokenSpec: parser_1.parserTokens[const_1.CheckboxNode.Label],
            tokenName: 'checkbox_label',
        },
        view: opts.labelView,
    }));
};
exports.CheckboxSpecs = CheckboxSpecs;
