"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImgSettingsButton = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const common_1 = require("../../../../../i18n/common");
const hooks_1 = require("../../../../../react-utils/hooks");
const useNodeEditing_1 = require("../../../../../react-utils/useNodeEditing");
const useNodeHovered_1 = require("../../../../../react-utils/useNodeHovered");
const remove_node_1 = require("../../../../../utils/remove-node");
const const_1 = require("../../const");
const ImageForm_1 = require("./ImageForm");
const ImgSettingsButton = function ({ node, view, getPos, nodeRef, updateAttributes }) {
    const [popupOpen, setPopupOpen, unsetPopupOpen] = (0, hooks_1.useBooleanState)(false);
    const placement = ['bottom-end', 'bottom-start'];
    const buttonRef = (0, react_1.useRef)(null);
    const isNodeHovered = (0, useNodeHovered_1.useNodeHovered)(nodeRef);
    const isButtonHovered = (0, useNodeHovered_1.useNodeHovered)(buttonRef);
    const [edit, setEditing, unsetEdit, toggleEdit] = (0, useNodeEditing_1.useNodeEditing)({ nodeRef, view });
    const visible = (isNodeHovered || isButtonHovered || popupOpen) && !edit;
    (0, react_1.useEffect)(() => {
        var _a;
        if ((_a = const_1.imageRendererKey.getState(view.state)) === null || _a === void 0 ? void 0 : _a.linkAdded) {
            setEditing();
        }
    }, [view, setEditing]);
    if (edit)
        return (react_1.default.createElement(ImageForm_1.ImageForm, { node: node, view: view, updateAttributes: updateAttributes, dom: nodeRef, unsetEdit: unsetEdit }));
    return visible ? (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(uikit_1.Button, { onClick: setPopupOpen, ref: buttonRef, size: "s", view: 'raised', style: { position: 'absolute', right: '3px', top: '3px' } },
            react_1.default.createElement(uikit_1.Icon, { data: icons_1.Ellipsis })),
        react_1.default.createElement(uikit_1.Popup, { open: popupOpen, anchorRef: buttonRef, onClose: unsetPopupOpen, placement: placement },
            react_1.default.createElement(uikit_1.Menu, null,
                react_1.default.createElement(uikit_1.Menu.Item, { onClick: () => {
                        toggleEdit();
                        unsetPopupOpen();
                    } }, (0, common_1.i18n)('edit')),
                react_1.default.createElement(uikit_1.Menu.Item, { onClick: () => {
                        const pos = getPos();
                        if (pos === undefined)
                            return;
                        (0, remove_node_1.removeNode)({
                            node,
                            pos,
                            tr: view.state.tr,
                            dispatch: view.dispatch,
                        });
                        view.focus();
                    } }, (0, common_1.i18n)('delete')))))) : null;
};
exports.ImgSettingsButton = ImgSettingsButton;
