"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WYfmHtmlBlockNodeView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const react_dom_1 = require("react-dom");
const behavior_1 = require("../../../behavior");
const const_1 = require("../YfmHtmlBlockSpecs/const");
const YfmHtmlBlockView_1 = require("./YfmHtmlBlockView");
class WYfmHtmlBlockNodeView {
    constructor({ node, view, getPos, options, }) {
        this.options = {};
        this.node = node;
        this.dom = document.createElement('div');
        this.dom.classList.add('yfm-html-block-container');
        this.dom.contentEditable = 'false';
        this.view = view;
        this.getPos = getPos;
        this.options = options;
        this.renderItem = (0, behavior_1.getReactRendererFromState)(view.state).createItem('yfmHtmlBlock-view', this.renderYfmHtmlBlock.bind(this));
    }
    update(node) {
        if (node.type !== this.node.type)
            return false;
        if (node.attrs[const_1.YfmHtmlBlockConsts.NodeAttrs.newCreated] !==
            this.node.attrs[const_1.YfmHtmlBlockConsts.NodeAttrs.newCreated])
            return false;
        this.node = node;
        this.renderItem.rerender();
        return true;
    }
    destroy() {
        this.renderItem.remove();
    }
    ignoreMutation() {
        return true;
    }
    stopEvent(e) {
        const target = e.target;
        if (typeof target.className === 'string' &&
            target.className.includes('prosemirror-stop-event')) {
            return true;
        }
        return false;
    }
    onChange(attrs) {
        const pos = this.getPos();
        if (pos === undefined)
            return;
        const tr = this.view.state.tr.setNodeMarkup(pos, undefined, Object.assign(Object.assign({}, this.node.attrs), attrs), []);
        this.view.dispatch(tr);
    }
    renderYfmHtmlBlock() {
        return (0, react_dom_1.createPortal)(react_1.default.createElement(YfmHtmlBlockView_1.YfmHtmlBlockView, { useConfig: this.options.useConfig, view: this.view, onChange: this.onChange.bind(this), node: this.node, getPos: this.getPos }), this.dom);
    }
}
exports.WYfmHtmlBlockNodeView = WYfmHtmlBlockNodeView;
