"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmHtmlBlockSpecs = exports.yfmHtmlBlockNodeName = void 0;
// eslint-disable-next-line import/no-extraneous-dependencies
const html_extension_1 = require("@diplodoc/html-extension");
const const_1 = require("./const");
var const_2 = require("./const");
Object.defineProperty(exports, "yfmHtmlBlockNodeName", { enumerable: true, get: function () { return const_2.yfmHtmlBlockNodeName; } });
const YfmHtmlBlockSpecsExtension = (builder, { nodeView }) => {
    builder
        .configureMd((md) => md.use((0, html_extension_1.transform)({ bundle: false }), {}))
        .addNode(const_1.YfmHtmlBlockConsts.NodeName, () => ({
        fromMd: {
            tokenSpec: {
                name: const_1.YfmHtmlBlockConsts.NodeName,
                type: 'node',
                noCloseToken: true,
                getAttrs: (token) => { var _a; return Object.fromEntries((_a = token.attrs) !== null && _a !== void 0 ? _a : []); },
            },
        },
        spec: {
            group: 'block',
            attrs: {
                [const_1.YfmHtmlBlockConsts.NodeAttrs.class]: { default: 'yfm-html' },
                [const_1.YfmHtmlBlockConsts.NodeAttrs.frameborder]: { default: '' },
                [const_1.YfmHtmlBlockConsts.NodeAttrs.srcdoc]: { default: '' },
                [const_1.YfmHtmlBlockConsts.NodeAttrs.style]: { default: null },
                [const_1.YfmHtmlBlockConsts.NodeAttrs.newCreated]: { default: null },
            },
            toDOM: (node) => ['iframe', node.attrs],
        },
        toMd: (state, node) => {
            state.write('::: html');
            state.write('\n');
            state.write(node.attrs[const_1.YfmHtmlBlockConsts.NodeAttrs.srcdoc]);
            state.ensureNewLine();
            state.write(':::');
            state.closeBlock(node);
        },
        view: nodeView,
    }));
};
exports.YfmHtmlBlockSpecs = Object.assign(YfmHtmlBlockSpecsExtension, const_1.YfmHtmlBlockConsts);
