"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmHtmlBlock = void 0;
const YfmHtmlBlockNodeView_1 = require("./YfmHtmlBlockNodeView");
const YfmHtmlBlockSpecs_1 = require("./YfmHtmlBlockSpecs");
const const_1 = require("./YfmHtmlBlockSpecs/const");
const actions_1 = require("./actions");
const YfmHtmlBlock = (builder, options) => {
    builder.use(YfmHtmlBlockSpecs_1.YfmHtmlBlockSpecs, {
        nodeView: YfmHtmlBlockNodeViewFactory(options),
    });
    builder.addAction(const_1.YfmHtmlBlockAction, () => actions_1.addYfmHtmlBlock);
};
exports.YfmHtmlBlock = YfmHtmlBlock;
const YfmHtmlBlockNodeViewFactory = (options) => () => (node, view, getPos) => {
    return new YfmHtmlBlockNodeView_1.WYfmHtmlBlockNodeView({ node, view, getPos, options });
};
