"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializerTokens = void 0;
const const_1 = require("./const");
exports.serializerTokens = {
    [const_1.YfmTableNode.Table]: (state, node) => {
        state.ensureNewLine();
        state.write('#|');
        state.ensureNewLine();
        state.renderContent(node);
        state.write('|#');
        state.ensureNewLine();
        state.closeBlock();
        state.write('\n');
    },
    [const_1.YfmTableNode.Body]: (state, node) => {
        state.renderContent(node);
    },
    [const_1.YfmTableNode.Row]: (state, node) => {
        state.write('||');
        state.ensureNewLine();
        state.write('\n');
        state.renderContent(node);
        state.write('||');
        state.ensureNewLine();
    },
    [const_1.YfmTableNode.Cell]: (state, node, parent) => {
        state.renderContent(node);
        const isLastCell = parent.lastChild === node;
        if (!isLastCell) {
            state.write('|');
            state.ensureNewLine();
            state.write('\n');
        }
    },
};
