"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.yfmTableView = exports.viewB = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const react_dom_1 = require("react-dom");
const classname_1 = require("../../../../../classname");
const core_1 = require("../../../../../core");
const ErrorBoundary_1 = require("../../../../../react-utils/ErrorBoundary");
const table_utils_1 = require("../../../../../table-utils");
const ReactRenderer_1 = require("../../../../behavior/ReactRenderer");
const actions_1 = require("./actions");
const wrapperB = (0, classname_1.cn)('table-wrapper');
exports.viewB = (0, classname_1.cn)('table-view');
const yfmTableView = (node, view, getPos) => {
    const actions = (0, core_1.bindActions)(actions_1.controlActions)(view);
    const wrapperElem = document.createElement('div');
    wrapperElem.classList.add(wrapperB());
    const tableElem = document.createElement('table');
    tableElem.classList.add((0, exports.viewB)());
    const viewElem = document.createElement('div');
    viewElem.classList.add((0, exports.viewB)('wrapper'));
    const controls = document.createElement('div');
    controls.setAttribute('contenteditable', 'false');
    const hackStrip = document.createElement('div');
    // this is a strip of a table height. it's a hack so that content of table doesn't get outside of editor borders
    // and thus editing buttons are not cropped
    hackStrip.classList.add((0, exports.viewB)('hack-strip'));
    viewElem.appendChild(hackStrip);
    viewElem.appendChild(tableElem);
    viewElem.appendChild(controls);
    wrapperElem.appendChild(viewElem);
    const components = [
        react_1.default.createElement("div", { className: (0, exports.viewB)('plus-button-controls', { bottom: true }), key: 1 },
            react_1.default.createElement(uikit_1.Button, { onClick: () => {
                    actions.appendRow.run({ tablePos: getPos() });
                }, className: (0, exports.viewB)('plus-button', { bottom: true }), view: 'normal' }, "+")),
        react_1.default.createElement("div", { className: (0, exports.viewB)('plus-button-controls', { right: true }), key: 2 },
            react_1.default.createElement(uikit_1.Button, { onClick: () => {
                    actions.appendColumn.run({ tablePos: getPos() });
                }, className: (0, exports.viewB)('plus-button', { right: true }), view: 'normal' }, "+")),
    ];
    const renderItem = (0, ReactRenderer_1.getReactRendererFromState)(view.state).createItem('yfm-table-plus-buttons', () => (0, react_dom_1.createPortal)(react_1.default.createElement(ErrorBoundary_1.ErrorLoggerBoundary, null, components), controls));
    return {
        dom: wrapperElem,
        contentDOM: tableElem,
        destroy() {
            renderItem.remove();
            viewElem.remove();
        },
        update(n) {
            const { rows: nRows, cols: nCols } = (0, table_utils_1.getTableDimensions)(n);
            const { rows, cols } = (0, table_utils_1.getTableDimensions)(node);
            return !(rows !== nRows || cols !== nCols);
        },
        ignoreMutation(mutation) {
            return mutation.type === 'childList' && mutation.target === controls;
        },
    };
};
exports.yfmTableView = yfmTableView;
