"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkForm = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const forms_1 = require("../i18n/forms");
const TextInput_1 = require("./TextInput");
const UrlInputRow_1 = require("./UrlInputRow");
const base_1 = tslib_1.__importDefault(require("./base"));
const utils_1 = require("./utils");
exports.LinkForm = react_1.default.memo(function LinkForm({ className, autoFocus, initialUrl, initialText, readOnlyText, onSubmit, onCancel, }) {
    const [url, setUrl] = react_1.default.useState(initialUrl !== null && initialUrl !== void 0 ? initialUrl : '');
    const [text, setText] = react_1.default.useState(initialText !== null && initialText !== void 0 ? initialText : '');
    const handleSubmit = () => {
        onSubmit({ url, text });
    };
    const inputEnterKeyHandler = (0, utils_1.enterKeyHandler)(handleSubmit);
    return (react_1.default.createElement(base_1.default.Form, { className: className },
        react_1.default.createElement(base_1.default.Layout, null,
            react_1.default.createElement(base_1.default.Row, { label: (0, forms_1.i18n)('common_link'), help: (0, forms_1.i18n)('link_url_help'), control: react_1.default.createElement(UrlInputRow_1.UrlInputRow, { href: url, input: react_1.default.createElement(TextInput_1.TextInputFixed, { size: "s", view: "normal", value: url, onUpdate: setUrl, autoFocus: autoFocus, placeholder: "https://", onKeyPress: inputEnterKeyHandler }) }) }),
            react_1.default.createElement(base_1.default.Row, { label: (0, forms_1.i18n)('link_text'), help: (0, forms_1.i18n)('link_text_help'), control: react_1.default.createElement(uikit_1.TextInput, { size: "s", view: "normal", value: text, onUpdate: setText, disabled: readOnlyText, onKeyPress: inputEnterKeyHandler }) })),
        react_1.default.createElement(base_1.default.Footer, { onCancel: onCancel, onSubmit: handleSubmit })));
});
