"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextAreaFixed = exports.TextInputFixed = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const react_use_1 = require("react-use");
// TODO: remove after fix https://github.com/yandex-cloud/uikit/issues/133
exports.TextInputFixed = react_1.default.forwardRef((props, ref) => {
    var _a;
    const inputRef = react_1.default.useRef(null);
    const controlRef = (_a = props.controlRef) !== null && _a !== void 0 ? _a : inputRef;
    (0, react_use_1.useEffectOnce)(() => {
        if (props.autoFocus) {
            setTimeout(() => {
                var _a;
                (_a = controlRef.current) === null || _a === void 0 ? void 0 : _a.focus();
            }, 30);
        }
    });
    // eslint-disable-next-line jsx-a11y/no-autofocus
    return react_1.default.createElement(uikit_1.TextInput, Object.assign({ ref: ref }, props, { controlRef: controlRef, autoFocus: false }));
});
exports.TextInputFixed.displayName = 'TextInputFixed';
// TODO: remove after fix https://github.com/yandex-cloud/uikit/issues/133
exports.TextAreaFixed = react_1.default.forwardRef((props, ref) => {
    var _a;
    const inputRef = react_1.default.useRef(null);
    const controlRef = (_a = props.controlRef) !== null && _a !== void 0 ? _a : inputRef;
    (0, react_use_1.useEffectOnce)(() => {
        if (props.autoFocus) {
            setTimeout(() => {
                var _a;
                (_a = controlRef.current) === null || _a === void 0 ? void 0 : _a.focus();
            }, 30);
        }
    });
    return react_1.default.createElement(uikit_1.TextArea, Object.assign({ ref: ref }, props, { controlRef: controlRef, autoFocus: false }));
});
exports.TextAreaFixed.displayName = 'TextInputFixed';
