import type { Extension, StateCommand } from '@codemirror/state';
import { EditorView, EditorViewConfig } from '@codemirror/view';
import { ReactRenderStorage } from '../../extensions';
import { FileUploadHandler } from './files-upload-facet';
export declare type CreateCodemirrorParams = {
    doc: EditorViewConfig['doc'];
    placeholderText: string;
    onCancel: () => void;
    onSubmit: () => void;
    onChange: () => void;
    onDocChange: () => void;
    onScroll: (event: Event) => void;
    reactRenderer: ReactRenderStorage;
    uploadHandler?: FileUploadHandler;
    needImgDimms?: boolean;
    extraMarkupExtensions?: Extension[];
};
export declare function createCodemirror(params: CreateCodemirrorParams): EditorView;
export declare function withLogger(action: string, command: StateCommand): StateCommand;
