import React from 'react';
import { NodeType } from 'prosemirror-model';
import { EditorView } from 'prosemirror-view';
import { BaseTooltipNode, BaseTooltipPluginOptions, BaseTooltipPluginView, TooltipOnChangeCallback } from '../BaseTooltip';
declare type ButtonContent = (view: EditorView, node: BaseTooltipNode, toggleEdit: () => void) => React.ReactElement;
declare type FormContent = (view: EditorView, node: BaseTooltipNode, onChange?: TooltipOnChangeCallback) => React.ReactElement;
interface TooltipMenuOptions extends BaseTooltipPluginOptions {
    disableHideOnBlur?: boolean;
    buttonContent: ButtonContent;
    formContent: FormContent;
}
export declare class TooltipButtonPluginView extends BaseTooltipPluginView {
    private enableHideOnBlur?;
    private forceEdit;
    private buttonContent;
    private formContent;
    constructor(view: EditorView, options: TooltipMenuOptions);
    toggleEdit: () => void;
    destroy(): void;
    protected renderContent(currentNode: BaseTooltipNode): React.ReactNode;
    protected setCurrentNode(node: NodeType): void;
    protected updateTooltipView(): void;
    private onViewFocus;
}
export {};
