"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarButtonPopup = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const react_use_1 = require("react-use");
const ToolbarButton_1 = require("./ToolbarButton");
function ToolbarButtonPopup(props) {
    const { className, editor, isActive, isEnable, renderPopup } = props, buttonProps = tslib_1.__rest(props, ["className", "editor", "isActive", "isEnable", "renderPopup"]);
    const buttonRef = (0, react_1.useRef)(null);
    const [open, setOpen] = (0, react_use_1.useBoolean)(false);
    const active = isActive(editor);
    const enabled = isEnable(editor);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(ToolbarButton_1.ToolbarButtonView, Object.assign({}, buttonProps, { ref: buttonRef, active: active, enabled: enabled, className: className, onClick: () => setOpen() })),
        open &&
            renderPopup(Object.assign(Object.assign({}, props), { anchorRef: buttonRef, hide: () => setOpen(false) }))));
}
exports.ToolbarButtonPopup = ToolbarButtonPopup;
