import React from 'react';
import type { ToasterPublicMethods } from '@gravity-ui/uikit';
import { ClassNameProps } from '../classname';
import type { Editor } from './Editor';
import { MToolbarData, MToolbarItemData } from './config/markup';
import { WToolbarData, WToolbarItemData } from './config/wysiwyg';
import '../styles/styles.css';
import './MarkdownEditorView.css';
export declare const cnEditorComponent: import("@bem-react/classname").ClassNameFormatter;
export declare type MarkdownEditorViewProps = ClassNameProps & {
    editor?: Editor;
    autofocus?: boolean;
    markupToolbarConfig?: MToolbarData;
    wysiwygToolbarConfig?: WToolbarData;
    markupHiddenActionsConfig?: MToolbarItemData[];
    wysiwygHiddenActionsConfig?: WToolbarItemData[];
    /** @default true */
    settingsVisible?: boolean;
    toaster: ToasterPublicMethods;
    stickyToolbar: boolean;
};
export declare const MarkdownEditorView: React.ForwardRefExoticComponent<ClassNameProps & {
    editor?: Editor | undefined;
    autofocus?: boolean | undefined;
    markupToolbarConfig?: MToolbarData | undefined;
    wysiwygToolbarConfig?: WToolbarData | undefined;
    markupHiddenActionsConfig?: MToolbarItemData[] | undefined;
    wysiwygHiddenActionsConfig?: WToolbarItemData[] | undefined;
    /** @default true */
    settingsVisible?: boolean | undefined;
    toaster: ToasterPublicMethods;
    stickyToolbar: boolean;
} & React.RefAttributes<HTMLDivElement>>;
