import type { ActionStorage } from '../../../core';
import { AutocompleteAction, AutocompleteHandler } from '../Autocomplete';
import type { Config } from './types';
declare module 'prosemirror-model' {
    interface NodeSpec {
        commandMenu?: boolean;
    }
}
export declare type CommandHandlerParams = {
    actions: Config;
    storage: ActionStorage;
    nodesIgnoreList?: readonly string[];
};
export declare class CommandHandler implements AutocompleteHandler {
    #private;
    constructor({ actions, storage, nodesIgnoreList }: CommandHandlerParams);
    onOpen(action: AutocompleteAction): boolean;
    onFilter(action: AutocompleteAction): boolean;
    onArrow(action: AutocompleteAction): boolean;
    onEnter(action: AutocompleteAction): boolean;
    onClose(action: AutocompleteAction): boolean;
    onDestroy(): void;
    private closeAutocomplete;
    private shouldIgnore;
    private select;
    private filterActions;
    private render;
    private onItemClick;
    private updateState;
    private clear;
    private createMenuRenderItem;
    private findAnchor;
}
