import { ImagePaste } from './ImagePaste';
import { ImageWidget } from './ImageWidget';
import { ImgSizeSpecs } from './ImgSizeSpecs';
import { addImage } from './actions';
import { addImageAction } from './const';
import { imgSizeNodeViewPlugin } from './plugins/ImgSizeNodeView';
export const ImgSize = (builder, opts) => {
    builder.use(ImgSizeSpecs, opts);
    builder.use(ImageWidget, {
        imageUploadHandler: opts.imageUploadHandler,
        needToSetDimensionsForUploadedImages: Boolean(opts.needToSetDimensionsForUploadedImages),
    });
    if (opts.imageUploadHandler) {
        builder.use(ImagePaste, {
            imageUploadHandler: opts.imageUploadHandler,
            needDimmensions: Boolean(opts.needToSetDimensionsForUploadedImages),
        });
    }
    builder.addAction(addImageAction, ({ schema }) => addImage(schema));
    builder.addPlugin(imgSizeNodeViewPlugin);
};
