import { Node, NodeType } from 'prosemirror-model';
import { UploadSuccessItem } from '../../../utils/upload';
import { ImgSizeAttr } from '../../specs';
export declare function isImageNode(node: Node): boolean;
export declare type CreateImageNodeOptions = {
    needDimmensions: boolean;
};
export declare const createImageNode: (imgType: NodeType, opts: CreateImageNodeOptions) => ({ result, file }: UploadSuccessItem) => Promise<Node>;
export declare function loadImage(imgFile: File): Promise<HTMLImageElement>;
export declare function getImageSize(img: HTMLImageElement): {
    [ImgSizeAttr.Width]?: string;
    [ImgSizeAttr.Height]?: string;
};
