import attrsPlugin from 'markdown-it-attrs'; // eslint-disable-line import/no-extraneous-dependencies
import { noop } from '../../../../lodash';
const defaultAttrsOpts = {
    allowedAttributes: ['id'],
};
export const YfmConfigsSpecs = (builder, opts) => {
    const attrsOpts = Object.assign(Object.assign({}, defaultAttrsOpts), opts.attrs);
    builder.configureMd((md) => md.use(attrsPlugin, attrsOpts), { text: false });
    // ignore yfm lint token
    builder.addNode('__yfm_lint', () => ({
        spec: {},
        fromMd: { tokenSpec: { name: '__yfm_lint', type: 'node', ignore: true } },
        toMd: noop,
    }));
};
