import log from '@diplodoc/transform/lib/log';
import yfmPlugin from '@diplodoc/transform/lib/plugins/cut';
import { CutNode } from './const';
import { parserTokens } from './parser';
import { getSchemaSpecs } from './schema';
import { serializerTokens } from './serializer';
export { CutNode, cutType, cutTitleType, cutContentType } from './const';
export const YfmCutSpecs = (builder, opts) => {
    const schemaSpecs = getSchemaSpecs(opts, builder.context.get('placeholder'));
    builder
        .configureMd((md) => md.use(yfmPlugin, { log }))
        .addNode(CutNode.Cut, () => ({
        spec: schemaSpecs[CutNode.Cut],
        toMd: serializerTokens[CutNode.Cut],
        fromMd: {
            tokenSpec: parserTokens[CutNode.Cut],
        },
        view: opts.cutView,
    }))
        .addNode(CutNode.CutTitle, () => ({
        spec: schemaSpecs[CutNode.CutTitle],
        toMd: serializerTokens[CutNode.CutTitle],
        fromMd: {
            tokenSpec: parserTokens[CutNode.CutTitle],
        },
        view: opts.cutTitleView,
    }))
        .addNode(CutNode.CutContent, () => ({
        spec: schemaSpecs[CutNode.CutContent],
        toMd: serializerTokens[CutNode.CutContent],
        fromMd: {
            tokenSpec: parserTokens[CutNode.CutContent],
        },
        view: opts.cutContentView,
    }));
};
