// eslint-disable-next-line import/no-extraneous-dependencies
import { transform } from '@diplodoc/html-extension';
import { YfmHtmlBlockConsts } from './const';
export { yfmHtmlBlockNodeName } from './const';
const YfmHtmlBlockSpecsExtension = (builder, { nodeView }) => {
    builder
        .configureMd((md) => md.use(transform({ bundle: false }), {}))
        .addNode(YfmHtmlBlockConsts.NodeName, () => ({
        fromMd: {
            tokenSpec: {
                name: YfmHtmlBlockConsts.NodeName,
                type: 'node',
                noCloseToken: true,
                getAttrs: (token) => { var _a; return Object.fromEntries((_a = token.attrs) !== null && _a !== void 0 ? _a : []); },
            },
        },
        spec: {
            group: 'block',
            attrs: {
                [YfmHtmlBlockConsts.NodeAttrs.class]: { default: 'yfm-html' },
                [YfmHtmlBlockConsts.NodeAttrs.frameborder]: { default: '' },
                [YfmHtmlBlockConsts.NodeAttrs.srcdoc]: { default: '' },
                [YfmHtmlBlockConsts.NodeAttrs.style]: { default: null },
                [YfmHtmlBlockConsts.NodeAttrs.newCreated]: { default: null },
            },
            toDOM: (node) => ['iframe', node.attrs],
        },
        toMd: (state, node) => {
            state.write('::: html');
            state.write('\n');
            state.write(node.attrs[YfmHtmlBlockConsts.NodeAttrs.srcdoc]);
            state.ensureNewLine();
            state.write(':::');
            state.closeBlock(node);
        },
        view: nodeView,
    }));
};
export const YfmHtmlBlockSpecs = Object.assign(YfmHtmlBlockSpecsExtension, YfmHtmlBlockConsts);
