import React from 'react';
import { SelectOption, SelectOptionGroup } from '@gravity-ui/uikit';
import { Node } from 'prosemirror-model';
import { EditorView } from 'prosemirror-view';
import { BaseTooltipNode, BaseTooltipPluginOptions, BaseTooltipPluginView } from '../BaseTooltip';
interface TooltipSelectOptions extends BaseTooltipPluginOptions {
    buttonText?: (node: Node) => string;
    items?: SelectOption[] | SelectOptionGroup[];
    buildAttrs: (selectedValue: string) => Record<string, string>;
    withSearch?: boolean;
    disableHideOnBlur?: boolean;
}
export declare class TooltipSelectPluginView extends BaseTooltipPluginView {
    private buttonText?;
    private items?;
    private buildAttrs;
    private withSearch;
    private enableHideOnBlur?;
    constructor(view: EditorView, options: TooltipSelectOptions);
    destroy(): void;
    protected renderContent(currentNode: BaseTooltipNode): React.ReactNode;
    protected onOutsideClick: () => void;
    private onViewFocus;
}
export {};
