import { DeflistSpecs, SubscriptSpecs, SuperscriptSpecs, UnderlineSpecs, } from '../extensions/specs';
import { CheckboxSpecs, ImgSizeSpecs, MonospaceSpecs, VideoSpecs, YfmConfigsSpecs, YfmCutSpecs, YfmFileSpecs, YfmHeadingSpecs, YfmNoteSpecs, YfmTableSpecs, YfmTabsSpecs, } from '../extensions/yfm/specs';
import { DefaultSpecsPreset } from './default-specs';
export const YfmSpecsPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    builder.use(DefaultSpecsPreset, Object.assign(Object.assign({}, opts), { image: false, heading: false }));
    builder
        .use(DeflistSpecs, (_a = opts.deflist) !== null && _a !== void 0 ? _a : {})
        .use(SubscriptSpecs)
        .use(SuperscriptSpecs)
        .use(UnderlineSpecs)
        .use(CheckboxSpecs, (_b = opts.checkbox) !== null && _b !== void 0 ? _b : {})
        .use(ImgSizeSpecs, (_c = opts.imgSize) !== null && _c !== void 0 ? _c : {})
        .use(MonospaceSpecs)
        .use(VideoSpecs, (_d = opts.video) !== null && _d !== void 0 ? _d : {})
        .use(YfmConfigsSpecs, (_e = opts.yfmConfigs) !== null && _e !== void 0 ? _e : {})
        .use(YfmCutSpecs, (_f = opts.yfmCut) !== null && _f !== void 0 ? _f : {})
        .use(YfmNoteSpecs, (_g = opts.yfmNote) !== null && _g !== void 0 ? _g : {})
        .use(YfmFileSpecs)
        .use(YfmHeadingSpecs, (_h = opts.yfmHeading) !== null && _h !== void 0 ? _h : {})
        .use(YfmTableSpecs, (_j = opts.yfmTable) !== null && _j !== void 0 ? _j : {})
        .use(YfmTabsSpecs, (_k = opts.yfmTabs) !== null && _k !== void 0 ? _k : {});
};
